/*
  AweMUD - log.h
  Copyright (c) 2000-2002, AwesomePlay Productions, Inc.
  All rights reserved.
  
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:
  
   * Redistributions of source code must retain the above copyright notice,
     this list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
  
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
  ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
  DAMAGE.
*/

#ifndef __LOG_H__
#define __LOG_H__

#define LOG_NONE 0
#define LOG_CRITICAL 1
#define LOG_IMPORTANT 2
#define LOG_SYSTEM 3
#define LOG_MESSAGES 4
#define LOG_INFORMATION 5
#define LOG_POINTLESS 6
#define LOG_PEDANTIC 7

#include "strings.h"

class
logfile
{
	protected:
	string_t file;
	FILE *f;
	int log_level;

	public:
	logfile (const char *);
	logfile (FILE *, const char *);
	~logfile (void);

	void print (int, const char *);

	void reset (void);

	void set_verbose (int v) { log_level = v; }
	string_t get_file (void) const { return file; }
};

int message (char const *, ...);
int message (int, char const *, ...);

#endif
