/*
  AweMUD - race.h
  Copyright (c) 2000-2002, AwesomePlay Productions, Inc.
  All rights reserved.
  
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:
  
   * Redistributions of source code must retain the above copyright notice,
     this list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
  
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
  ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
  DAMAGE.
*/

#ifndef RACE_H
#define RACE_H

#include <vector>

#include "strings.h"
#include "registry.h"

#ifndef NUM_STATS
#define NUM_STATS 6
#endif

/* store information about a race */
class
char_race
{
	protected:
	string_t name;
	string_t adj;
	string_t body;

	int age_base, age_dice, age_sides;

	int stats[NUM_STATS];

	public:
	int load (const xmlNodePtr);

	int get_rand_age (void) const;
	int get_stat (int i) const { if (i >= 0 && i < NUM_STATS) return stats[i] ; else return 0; }

	string_t get_name (void) const { return name; }
	string_t get_adj (void) const { return adj; }
	string_t get_body (void) const { return body; }
};

typedef registry<char_race> race_registry;

extern race_registry races;

#endif
