/*
  AweMUD - types.h
  Copyright (c) 2000-2002, AwesomePlay Productions, Inc.
  All rights reserved.
  
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:
  
   * Redistributions of source code must retain the above copyright notice,
     this list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
  
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
  ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
  DAMAGE.
*/

#ifndef __TYPES__
#define __TYPES__

typedef unsigned char		uchar;
typedef unsigned short		ushort;
typedef unsigned int		uint;
typedef unsigned long		ulong;
typedef unsigned long long	ulonglong;

typedef char			int8;
typedef unsigned char		uint8;

typedef short int		int16;
typedef unsigned short int	uint16;

typedef int			int32;
typedef unsigned int		uint32;

typedef long long		int64;
typedef unsigned long long	uint64;

typedef const char		cchar;

typedef int			boolean;

typedef uint32			flags_type;

#ifndef FALSE
#define FALSE (0)
#endif

#ifndef TRUE
#define TRUE (!FALSE)
#endif

#ifndef NULL
#define NULL ((void *)0L)
#endif

#define SET_FLAG(v,f) ((v) |= (f))
#define CHECK_FLAG(v,f) ((v) & (f))
#define CLEAR_FLAG(v,f) ((v) &= ~(f))
#define TOGGLE_FLAG(v,f) ((v) = ((v) & (f)) ? ((v) & ~(f)) : ((v) | (f)))
#define SET_FLAG_TO(v,f,b) ((b) ? (SET_FLAG(v,f)) : (CLEAR_FLAG(v,f)))

#define INT_TO_FLAG(i) (1 << i)

#endif
