/*
  AweMUD - xml.h
  Copyright (c) 2000-2002, AwesomePlay Productions, Inc.
  All rights reserved.
  
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:
  
   * Redistributions of source code must retain the above copyright notice,
     this list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
  
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
  ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
  DAMAGE.
*/
#include "libxml/tree.h"
#include "strings.h"

xmlDocPtr xml_open (const char *);
void xml_free (xmlDocPtr);
xmlNodePtr xml_root (xmlDocPtr);
xmlNodePtr xml_find_node (xmlNodePtr, const char *);
xmlNodePtr xml_next_node (xmlNodePtr, const char *);
string_t xml_prop (xmlNodePtr, const char *);
string_t xml_prop (xmlNodePtr, const char *, const char *);
int xml_prop (xmlNodePtr, const char *, int);
string_t xml_text (xmlNodePtr);
string_t xml_find_text (xmlNodePtr, const char *);

/* save/create XML */
xmlDocPtr xml_create (const char *, const char *);
xmlNodePtr xml_add_node (xmlNodePtr, const char *);
void xml_set_prop (xmlNodePtr, const char *, const char *);
void xml_set_prop (xmlNodePtr, const char *, int);
void xml_set_text (xmlNodePtr, const char *);
int xml_save (xmlDocPtr, const char *);
void xml_add_text (xmlNodePtr, const char *, const char *);
